#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "libweb/webutil.h"

/*----------------------------------------------------------------------------*/

int main( int argc, char* argv[] )
{
   entry entries[MAX_ENTRIES];
   register int x, m = 0;
   int cl, got_name = 0, got_email = 0, got_comments = 0;
   FILE *fp;

   printf( "Content-type: text/html%c%c", 10, 10 );

   if( strcmp( getenv( "REQUEST_METHOD" ), "POST" ) )
   {
      printf( "This script should be referenced with a METHOD of POST.\n" );
      printf( "If you don't understand this, see this ");
      printf( "<A HREF=\"http://www.ncsa.uiuc.edu/SDG/Software/Mosaic/Docs/fill-out-forms/overview.html\">forms overview</A>.%c", 10 );
      exit( 1 );
   }
   if( strcmp( getenv("CONTENT_TYPE"), "application/x-www-form-urlencoded") )
   {
      printf( "This script can only be used to decode form results.\n" );
      exit( 1 );
   }
   cl = atoi( getenv( "CONTENT_LENGTH" ) );

   for( x = 0; cl && ( !feof( stdin ) ); x++ )
   {
      m = x;
      entries[x].val = fmakeword( stdin, '&', &cl );
      plustospace( entries[x].val);
      unescape_url( entries[x].val );
      entries[x].name = makeword( entries[x].val, '=' );
   }

   printf( "<TITLE>Comments for Symbiotic Solutions</TITLE>%c", 10 );

   for( x = 0; x <= m; x++ )
   {
      if( strcmp( entries[x].name, "name" ) == 0 )
      {
         if( entries[x].val != 0 && strcmp( entries[x].val, "" ) != 0 )
            got_name = 1;
         else
            printf( "You didn't fill in field 'Name'.%c", 10 );
      }
      else if( strcmp( entries[x].name, "email" ) == 0 )
      {
         if( entries[x].val != 0 && strcmp( entries[x].val, "" ) != 0 )
            got_email = 1;
         else
            printf( "You didn't fill in field 'Email address'.%c", 10 );
      }
      else if( strcmp( entries[x].name, "comments" ) == 0 )
      {
         if( entries[x].val != 0 && strcmp( entries[x].val, "" ) != 0 )
            got_comments = 1;
         else
            printf( "You didn't fill in field 'Comments'.%c", 10 );
      }
   }

   if( got_name && got_email && got_comments )
   {
      fp = popen( "mail -s Comments noik@db.toronto.edu", "w" );
         
      for( x = 0; x <= m; x++ )
         fprintf( fp, "%s: %s\n", entries[x].name, entries[x].val );
      fclose( fp );

      printf( "<P>Thank you for sending us your comments!<BR>" );
   }
   else
   {
      printf( "Please go back to the previous page and try again.<BR>%c", 10 );
   }

   return 0;
}

/*----------------------------------------------------------------------------*/
